package com.gic.haoban.manage.service.service.out.impl;


import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.common.utils.PageUtil;
import com.gic.haoban.manage.api.dto.*;

import java.util.Collections;
import java.util.Date;
import java.util.List;

import com.github.pagehelper.PageInfo;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.api.base.commons.Page;
import com.gic.commons.util.EntityUtil;
import com.gic.haoban.manage.api.service.ExternalClerkRelatedApiService;
import com.gic.haoban.manage.service.dao.mapper.TabHaobanExternalClerkRelatedMapper;
import com.gic.haoban.manage.service.entity.TabHaobanExternalClerkRelated;
import com.github.pagehelper.PageHelper;

@Service
public class ExternalClerkRelatedApiServiceImpl implements ExternalClerkRelatedApiService{
	private static final Logger log = LogManager.getLogger(ExternalClerkRelatedApiServiceImpl.class);
	@Autowired
	private TabHaobanExternalClerkRelatedMapper tabHaobanExternalClerkRelatedMapper;
	@Override
	public List<ExternalClerkRelatedDTO> listByEnterpriseIdAndDate(
			String enterpriseId, Date date) {
		List<TabHaobanExternalClerkRelated> list = tabHaobanExternalClerkRelatedMapper.listByEnterpriseIdAndDate(enterpriseId,date);
		return EntityUtil.changeEntityListByJSON(ExternalClerkRelatedDTO.class,list);	
	}
	@Override
	public Page<ExternalClerkRelatedDTO> pageMemberUnionByParams(List<String> userIdList, List<String> sendMemberIds,
			String enterpriseId, BasePageInfo pageInfo) {
		PageHelper.startPage(pageInfo.getPageNum(), pageInfo.getPageSize());
		return  PageUtil.changePageHelperToCurrentPage(tabHaobanExternalClerkRelatedMapper.pageMemberUnionByParams(userIdList,sendMemberIds,enterpriseId),ExternalClerkRelatedDTO.class);
	}
	@Override
	public List<ExternalClerkRelatedDTO> listByWxEnterpriseIdAndWxUserId(String wxUserId, String wxEnterpriseId) {
		
		return EntityUtil.changeEntityListByJSON(ExternalClerkRelatedDTO.class, tabHaobanExternalClerkRelatedMapper.listByWxEnterpriseIdAndWxUserId(wxUserId,wxEnterpriseId));
	}
	@Override
	public List<ExternalClerkRelatedDTO> listByWxEnterpriseIdAndWxUserIds(List<String> userIdList,
			String wxEnterpriseId) {
		if(userIdList == null || userIdList.isEmpty()){
			return Collections.EMPTY_LIST;
		}
		return EntityUtil.changeEntityListByJSON(ExternalClerkRelatedDTO.class, tabHaobanExternalClerkRelatedMapper.listByWxEnterpriseIdAndWxUserIds(userIdList,wxEnterpriseId));
	}

	@Override
	public ExternalClerkRelatedDTO getExternalClerkByRelationKeyAndPre(String relationKey) {
		TabHaobanExternalClerkRelated related = tabHaobanExternalClerkRelatedMapper.getByRelationKey(relationKey);
		return EntityUtil.changeEntityNew(ExternalClerkRelatedDTO.class, related);
	}

	@Override
	public Page<ExternalClerkRelatedDTO> pageExternalClerk(String wxEnterpriseId, String wxUserId, Integer statusFlag, BasePageInfo pageInfo) {
		PageHelper.startPage(pageInfo);
		List<TabHaobanExternalClerkRelated> ret = tabHaobanExternalClerkRelatedMapper.listByWxEnterpriseIdAndWxUserIdAndStatus(wxEnterpriseId, wxUserId, statusFlag);
        Page<ExternalClerkRelatedDTO> retPage = PageUtil.changePageHelperToCurrentPage(new PageInfo<>(ret), ExternalClerkRelatedDTO.class);
        return retPage;
    }

	@Override
	public boolean pushExternalByRelationKey(String relationKey) {
		tabHaobanExternalClerkRelatedMapper.pushExternalByRelationKey(relationKey);
		return true;
	}
}
